<template>
    <form action="" @submit.prevent="onSubmit">
                <div
                    class="form-item"
                    :class="{ errorInput: $v.currentForm.login.$error }"
                >
                    <label class="labelItem">Login:</label>
                    <p class="errorText" v-if="!$v.currentForm.login.required">Field is required!</p>
                    <p class="errorText" v-if="!$v.currentForm.login.minLength">Minimal length {{ $v.currentForm.login.$params.minLength.min }}!</p>
                    <input
                        v-model="currentForm.login"
                        :class="{ error: $v.currentForm.login.$error }"
                        @change="$v.currentForm.login.$touch()"
                    />
                </div>
                <div
                    class="form-item"
                    :class="{ errorInput: $v.currentForm.password.$error}"
                >
                    <label class="labelItem">Password:</label>
                    <p class="errorText" v-if="!$v.currentForm.password.required">Field is required!</p>
                    <p class="errorText" v-if="!$v.currentForm.password.minLength">Minimal length {{ $v.currentForm.password.$params.minLength.min }}!</p>
                     <input
                        v-model="currentForm.password"
                        :class="{ error: $v.currentForm.password.$error }"
                        @change="$v.currentForm.password.$touch()"
                    />
                </div>
                <hr>
                <button class="btn btnPrimary">Submit</button>
            </form>
</template>
<script>
import { required, minLength } from 'vuelidate/lib/validators'
import { PASSWORD_LENGTH as passwordLength, NAME_LENGTH as nameLength} from '@/Core/Constants.js'

export default {
    components: {
    },
    data() {
        return {
            currentForm: {
                login: '',
                password: '',
            },
            defaultForm: {
                login: '',
                password: '',
            }
        }
    },
    validations: {
        currentForm: {
            login: {
                required,
                minLength: minLength(nameLength)
            },
            password: {
                required,
                minLength: minLength(passwordLength)
            },
        },
    },
    methods: {
        onSubmit() {
            this.$v.$touch();
            if(!this.$v.$invalid) {
                this.sendData();
            }
            this.resetForm();
            this.closeForm()
        },
        resetForm() {
            this.currentForm = { ...this.defaultForm }
            this.$v.$reset();
        },
        closeForm() {
            this.$emit('close')
        },
        sendData() {
            const data = {
                Action: 'Login',
                Data: { ...this.currentForm }
            }
            console.log('Введенные данные: ', data)
        }
    }
}
</script>